( cEFa.F, 10sep09cht, for c_eFORTH )
( Copyrighted by Offete Enterprises, 2009 ,All rights reserved )

:: ?KEY  ?RX ;;
:: KEY   BEGIN ?RX UNTIL ;;      
:: EMIT  TX! ;;

CRR .( Common functions ) CRR
:: WITHIN ( u ul uh -- t ) \ ul <= u < uh
   OVER - >R - R> U< ;;

CRR .( Bits & Bytes ) CRR
:: >CHAR ( c -- c )
  $7F LIT AND DUP $7F LIT BL WITHIN
  IF DROP ( CHAR _ ) $5F LIT THEN ;;

CRR .( Memory access ) CRR
:: HERE ( -- a ) CP @ ;;
:: PAD ( -- a ) CP @ 100 LIT + ;;
:: TIB ( -- a ) 'TIB @ ;;

CRR
:: @EXECUTE ( a -- ) @ ?DUP IF EXECUTE THEN ;;
:: CMOVE ( b b u -- )
   FOR AFT OVER c@ OVER c! >R 1+ R> 1+ THEN NEXT 2DROP ;;
:: MOVE ( b b u -- )
   CELL/ FOR AFT OVER @ OVER ! >R CELL+ R> CELL+ THEN NEXT 2DROP ;;
:: FILL ( b u c -- )
  SWAP FOR SWAP AFT 2DUP c! 1+ THEN NEXT 2DROP ;;

CRR .( Numeric Output ) CRR \ single precision
:: DIGIT ( u -- c )
  9 LIT OVER < 7 LIT AND +
  ( CHAR 0 ) 30 LIT + 
;;
:: EXTRACT ( n base -- n c )
  0 LIT SWAP UM/MOD SWAP DIGIT ;;
:: <# ( -- ) PAD HLD ! ;;
:: HOLD ( c -- ) HLD @ 1- DUP HLD ! C!  ;;
:: # ( u -- u ) BASE @ EXTRACT HOLD ;;
:: #S ( u -- 0 ) BEGIN # DUP WHILE REPEAT ;;
CRR
:: SIGN ( n -- ) 0< IF ( CHAR - ) 2D LIT HOLD THEN ;;
:: #> ( w -- b u ) DROP HLD @ PAD OVER - ;;
:: str ( n -- b u ) DUP >R ABS <# #S R> SIGN #> ;;
:: HEX ( -- ) 10 LIT BASE ! ;;
:: DECIMAL ( -- ) 0A LIT BASE ! ;;

CRR .( Numeric Input ) CRR \ single precision
:: wupper ( w -- w' ) \ convert 4 byte in the word to uppercase
        5F5F5F5F LIT AND
        ;;
:: >upper ( c -- UC ) dup 61 LIT 7B LIT WITHIN IF 5F LIT AND THEN ;;
                
:: DIGIT? ( c base -- u t )
  >R ( CHAR 0 ) >upper 30 LIT - 9 LIT OVER <
  IF 7 LIT - DUP 0A LIT  < OR THEN DUP R> U< ;;
:: NUMBER? ( a -- n T | a F )
  BASE @ >R  0 LIT OVER COUNT ( a 0 b n)
  OVER c@ ( CHAR $ ) 24 LIT =
  IF HEX SWAP 1+ SWAP 1- THEN ( a 0 b' n')
  OVER c@ ( CHAR - ) 2D LIT = >R ( a 0 b n)
  SWAP R@ - SWAP R@ + ( a 0 b" n") ?DUP
  IF 1- ( a 0 b n) 
    FOR DUP >R c@ BASE @ DIGIT? 
      WHILE SWAP BASE @ * +  R> 1+ 
    NEXT DROP R@ ( b ?sign) IF NEGATE THEN SWAP 
      ELSE R> R> ( b index) 2DROP ( digit number) 2DROP 0 LIT 
      THEN DUP 
  THEN R> ( n ?sign) 2DROP R> BASE ! ;; 

CRR .( Basic I/O ) CRR
:: SPACE ( -- ) BL EMIT ;;
:: CHARS ( +n c -- )
  SWAP 0 LIT MAX
  FOR AFT DUP EMIT THEN NEXT DROP ;;
:: SPACES ( +n -- ) BL CHARS ;;

:: TYPE ( B U -- )
        FOR AFT DUP C@ >CHAR EMIT 1+ THEN NEXT DROP ;;

:: CR ( -- ) ( =CR )
  0A LIT 0D LIT EMIT EMIT ;;

:: do$ ( -- $adr )
     R> \ ADDR-COUNT
     R> \ $ADDR 
     DUP C@ OVER + 4 LIT + $FFFFFFFC LIT AND >R \ FLOW CONTINUED
     SWAP >R ;;

CRR
:: $"| ( -- a ) do$ ;; 
:: ."| ( -- ) do$ COUNT TYPE ;;
::  .R ( n +n -- )
  >R str R> OVER - SPACES TYPE ;;
:: U.R ( u +n -- )
  >R <# #S #> R> OVER - SPACES TYPE ;;
:: U. ( u -- ) <# #S #> SPACE TYPE ;;
::  . ( n -- )
  BASE @ 0A LIT  XOR
  IF U. EXIT THEN str SPACE TYPE ;;
:: ? ( a -- ) @ . ;;

CRR .( Parsing ) CRR
:: (parse) ( b u c -- b u delta ; <string> )
  tmp c! OVER >R DUP \ b u u
  IF 1- tmp c@ BL =
    IF              \ b u' \ 'skip'
      FOR BL OVER c@ - 0< NOT
        WHILE 1+
      NEXT ( b) R> DROP 0 LIT DUP EXIT \ all delim
        THEN  R>
    THEN OVER SWAP  \ b' b' u' \ 'scan'
    FOR tmp c@ OVER c@ -  tmp c@ BL =
      IF 0< THEN WHILE 1+
    NEXT DUP >R
      ELSE R> DROP DUP 1+ >R
      THEN OVER -  R>  R> - EXIT
  THEN ( b u) OVER R> - ;;

:: PACK$ ( b u a -- a ) \ always word-aligned
                DUP >R 
        2DUP + $FFFFFFFC LIT AND 0 LIT SWAP ! \ LAST WORD FILL 0 1ST
                2DUP C! 1+  \ B U A+1
                SWAP            \ B A U 
                CMOVE R> 
        ;;  \ BM+

:: PARSE ( c -- b u ; <string> )
  >R  TIB >IN @ +
  #TIB @ >IN @ -
  R> (parse) >IN +! ;;

:: TOKEN ( -- a ;; <string> ) 
   BL PARSE $1F LIT MIN
   HERE CELL+         \ S D N 
   PACK$  
  ;;


:: WORD ( c -- a ; <string> )
  PARSE HERE CELL+ PACK$ ;; \ BM+
  

CRR .( Dictionary Search ) CRR
:: NAME> ( a -- xt )
   DUP @ $1F LIT AND
   + CELL+ $FFFFFFFC LIT AND ;;
\ :: D+ ( m n -- m+1 n+1 ) >R 1+ R> 1+ ;;

:: SAME? ( a a c-c-c-u -- a a f \ -0+ )
 $1F LIT AND CELL/ 
 FOR AFT OVER R@ 4 LIT * + @ wupper
   OVER R@ 4 LIT * + @ wupper 
   - ?DUP
   IF R> DROP EXIT THEN
 THEN NEXT
 0 LIT ;;

:: find ( a va -- xt na | a 0 )
  SWAP         \ va a
  DUP @ tmp !  \ va a  \ get cell count
  DUP @ >R     \ va a  \ #XOR --- count and 1st 3 char
  cell+ SWAP      \ a' va  a'=a(#XOR)+4
  BEGIN @ DUP  \ a' na na
    IF DUP @ $FFFFFF3F LIT AND wupper
      R@ wupper XOR \ ignore lexicon bits
      IF 
        cell+ -1 LIT
      ELSE 
        cell+ tmp @ SAME?
      THEN
    ELSE 
        R> DROP SWAP cell- SWAP EXIT \ a 0
    THEN
  WHILE cell- cell-  \ a' la
  REPEAT R> DROP SWAP DROP
  cell- DUP NAME> SWAP ;;

:: NAME? ( a -- cfa na | a 0 )
   CONTEXT find ;;

CRR .( Terminal ) CRR
:: ^H ( b b b -- b b b ) \ backspace
  >R OVER R> SWAP OVER XOR
  IF ( =BkSp ) 8 LIT EMIT
     1-         BL EMIT \ distructive
     ( =BkSp ) 8 LIT EMIT \ backspace
  THEN ;;
:: TAP ( bot eot cur c -- bot eot cur )
  DUP EMIT OVER C! 1+ ;;
:: kTAP ( bot eot cur c -- bot eot cur )
  DUP ( =Cr ) 0D LIT XOR
  OVER ( =Lf ) 0A LIT XOR AND
  IF ( =BkSp ) 8 LIT XOR
    IF BL TAP ELSE ^H THEN
    EXIT
  THEN DROP SWAP DROP DUP  ;;

CRR

:: accept ( b u -- b u )
  OVER + OVER
  BEGIN 2DUP XOR
  WHILE  KEY  DUP BL -  5F LIT U<
    IF TAP ELSE kTAP THEN
  REPEAT DROP  OVER -
 ;;

:: EXPECT ( b u -- ) accept SPAN ! DROP ;;
:: QUERY ( -- )
\  $11 LIT EMIT \ X-ON for request next line
  TIB 50 LIT accept #TIB !
  DROP 0 LIT >IN ! ;;

CRR .( Error handling ) CRR
:: ABORT ( -- ) 'ABORT @EXECUTE ;;
:: abort" ( f -- )
  IF do$ COUNT TYPE ABORT THEN do$ DROP ;;

CRR .( Interpret ) CRR
:: ERROR ( a -- ) 
         space count type $3F LIT EMIT
         $1B LIT ( ESC) EMIT
         CR ABORT

:: $INTERPRET ( a -- )
  NAME? ?DUP
  IF C@ $40 LIT AND
    abort" $LIT  compile only" ( ?even)  EXECUTE  EXIT
  THEN 
  NUMBER? IF EXIT ELSE ERROR THEN 
  ;;
        
:: [ ( -- )
  forth_' $INTERPRET  >body forth_@ LIT 'EVAL !
  ;; IMMEDIATE
:: .OK ( -- ) CR
  forth_' $INTERPRET >body forth_@ LIT 'EVAL @ =
  IF >R >R >R DUP . R> DUP . R> DUP . R> DUP . ."| $LIT  fg>" 
  THEN ;;
:: EVAL ( -- )
  BEGIN TOKEN DUP @
  WHILE 'EVAL  @EXECUTE \ ?STACK
  REPEAT DROP .OK ;;

CRR .( Shell ) CRR
:: QUIT ( -- )
  ( =TIB) $100 LIT 'TIB ! [ BEGIN QUERY EVAL AGAIN

:: , ( w -- )  HERE DUP CELL+ CP ! ! ;;
:: LITERAL ( n -- ) 
	forth_' DOLIT >body forth_@ LIT , ,
        ;; IMMEDIATE 
:: ALLOT ( n -- )  3 LIT + $FFFFFFFC LIT AND  CP +! ;;

:: NAME> ( a -- xt )
   DUP @ $1F LIT AND
   + CELL+ $FFFFFFFC LIT AND ;; 

:: $," ( -- ) ( CHAR " ) 
        22 LIT WORD DUP C@ $FF LIT AND 
        + CELL+ $FFFFFFFC LIT AND CP ! ;; 

CRR .( Name Compiler ) CRR

:: ?UNIQUE ( a -- a )
  DUP NAME? 
  ?DUP IF COUNT 1F LIT AND SPACE TYPE ."| $LIT  reDef "
  THEN DROP ;;

:: $,n ( a -- )
  DUP @ IF ?UNIQUE
    ( na ) DUP NAME> CP ! 
    ( na ) DUP LAST ! \ for OVERT
    ( na ) CELL-
    ( la ) CONTEXT @ SWAP ! EXIT
  THEN ERROR
CRR .( Compiler Primitives ) CRR
:: ' ( -- xt )
  TOKEN NAME? IF EXIT THEN
  ERROR
:: [COMPILE] ( -- ; <string> )
  '  , ;; IMMEDIATE

CRR
:: COMPILE ( -- ) R> DUP @ , CELL+ >R ;;

CRR .( FORTH Compiler ) CRR

:: $COMPILE ( a -- )
  NAME? ?DUP
  IF @ $80 LIT AND
    IF EXECUTE
    ELSE ,
    THEN EXIT
  THEN  
  NUMBER?
  IF LITERAL EXIT
  THEN ERROR
  
:: OVERT ( -- ) \ the word is then VISIBLE from CONTEXT threading
        LAST @ CONTEXT ! ;; 
:: ] ( -- ) forth_' $COMPILE >body forth_@ LIT 'EVAL ! ;;
:: : ( -- ; <string> )
        TOKEN $,n ] 6 LIT , ;;
:: ; ( -- )
        forth_' EXIT >body forth_@  LIT , [ OVERT  ;; IMMEDIATE

CRR .( Tools ) CRR
:: dm+ ( b u -- b )
  OVER 6 LIT U.R 
  FOR AFT DUP @ 9 LIT U.R CELL+
  THEN NEXT ;;
:: DUMP ( b u -- )
  BASE @ >R HEX  1F LIT + 20 LIT /
  FOR AFT CR 8 LIT dm+
  THEN NEXT DROP R> BASE ! ;;
:: ?? ( a -- ) $10 LIT DUMP ;;

CRR
:: >NAME ( xt -- na | F )
  CONTEXT
  BEGIN @ DUP
  WHILE 2DUP NAME> XOR
    IF 1-
    ELSE SWAP DROP EXIT
    THEN
  REPEAT SWAP DROP ;;
:: .ID ( a -- )
  COUNT $01F LIT AND TYPE SPACE ;;

:: WORDS ( -- )
  CR CONTEXT
  BEGIN @ ?DUP
  WHILE DUP SPACE  .ID CELL-
  REPEAT ;;

:: FORGET ( -- )
  TOKEN NAME? ?DUP
  IF CELL- DUP CP ! 
     @ DUP CONTEXT ! LAST !
     DROP EXIT
  THEN ERROR

CRR

::   DIAGNOSE     ( - )
     $65 LIT
\     EMIT
\ 'F'  prove UM+ 0<         \ carry, TRUE, FALSE
     0 LIT 0< -2 LIT 0<     \ 0 FFFF
     UM+ DROP               \ FFFF ( -1)
     3 LIT UM+ UM+ DROP     \ 3
     $43 LIT UM+ DROP       \ 'F'
\     EMIT
\ 'o' logic: XOR AND OR
     $4F LIT $6F LIT XOR    \ 20h
     $F0 LIT AND
     $4F LIT OR
\     EMIT
\ 'r' stack: DUP OVER SWAP DROP
      8 LIT 6 LIT SWAP
      OVER XOR 3 LIT AND AND
      $70 LIT UM+ DROP      \ 'r'
\     EMIT
\ 't'-- prove BRANCH ?BRANCH
      0 LIT IF $3F LIT THEN
      -1 LIT IF $74 LIT ELSE $21 LIT THEN
\     EMIT
\ 'h' -- @ ! test memeory address
      $68 LIT $80 LIT !
      $80 LIT @
\     EMIT
\ 'M' -- prove >R R> R@
      $4D LIT >R R@ R> AND
\     EMIT
\ 'l'  -- prove 'next' can run
      61 LIT $A LIT FOR 1 LIT UM+ DROP NEXT
\     EMIT
\ 'emi' -- prove mul, dupy, popy
      $656D LIT $1000000 LIT UM*
      SWAP $100 LIT UM*
      SWAP DROP
\     EMIT EMIT
\ ' C' -- prove div
      $2043 LIT 0 LIT $100 LIT UM/MOD
\     EMIT EMIT
      ;;

:: COLD ( -- )
\	DIAGNOSE
 	CR ."| $LIT eForth in C, Ver 2.0, 2009 " CR
\       'BOOT @EXECUTE
        QUIT ;;
    
CRR .( Structures ) CRR
:: THEN ( A -- ) HERE SWAP ! ;; IMMEDIATE
:: FOR ( -- a ) forth_' >R >body forth_@ LIT , HERE ;; IMMEDIATE
:: BEGIN ( -- a ) HERE ;; IMMEDIATE
CRR
:: NEXT ( a -- )  forth_' DONEXT >body forth_@ LIT , , ;; IMMEDIATE
:: UNTIL ( a -- ) forth_' QBRANCH >body forth_@ LIT , , ;; IMMEDIATE
:: AGAIN ( a -- ) forth_' BRANCH >body forth_@ LIT , , ;; IMMEDIATE
:: IF ( -- A )   forth_' QBRANCH >body forth_@ LIT ,
	HERE 0 LIT , ;; IMMEDIATE
:: AHEAD ( -- A ) forth_' BRANCH >body forth_@ LIT ,
	HERE 0 LIT , ;; IMMEDIATE
CRR
:: REPEAT ( A a -- ) AGAIN THEN ;; IMMEDIATE
:: AFT ( a -- a A ) DROP AHEAD HERE SWAP ;; IMMEDIATE
:: ELSE ( A -- A )  AHEAD SWAP THEN ;; IMMEDIATE
:: WHEN ( a A -- a A a ) IF OVER ;; IMMEDIATE
:: WHILE ( a -- A a )    IF SWAP ;; IMMEDIATE

CRR
:: ABORT" ( -- ; <string> )
   forth_' abort" >body forth_@ LIT HERE !
   $," ;; IMMEDIATE
:: $" ( -- ; <string> )
   forth_' $"| >body forth_@ LIT HERE !
   $," ;; IMMEDIATE
:: ." ( -- ; <string> ) 
   forth_' ."| >body forth_@ LIT HERE !
   $," ;; IMMEDIATE

CRR
:: CODE ( -- ; <string> ) TOKEN $,n OVERT align ;;
:: CREATE ( -- ; <string> ) 
        CODE $203D LIT , ;;
:: VARIABLE ( -- ; <string> ) CREATE 0 LIT , ;;
:: CONSTANT CODE $2004  LIT , , ;;
:: DOES ( -- ) R> LAST @ NAME> ! ;;

CRR
(makeHead) .( ( -- ) 29 LIT PARSE TYPE ;; IMMEDIATE
\ (makeHead) \ ( -- ) #TIB @ >IN ! ;;       IMMEDIATE
(makeHead) \ ( -- ) $A LIT WORD DROP ;; IMMEDIATE \ fix:03.6.19, fix:030722-add DROP
(makeHead) ( 29 LIT PARSE 2DROP ;;        IMMEDIATE
(makeHead) COMPILE-ONLY $40 LIT LAST @ +! ;;
(makeHead) IMMEDIATE $80 LIT LAST @ +! ;;

CRR

