( cefMEATa.F, 10sep09cht, e_eForth Project )

HEX
variable debugging?
\ -1 debugging? !

: .head ( addr -- addr )
   SPACE >IN @ 20 WORD COUNT TYPE >IN !
   DUP . 
   ;

: CR CR
   debugging? @
   IF .S KEY 0D = IF ." DONE" QUIT THEN
   THEN
   ;

: BREAK CR
   .S KEY 0D = IF ." DONE" QUIT THEN
   ;

: forth_' ' ;
: forth_dup DUP ;
: forth_drop DROP ;
: forth_over OVER ;
: forth_swap SWAP ;
: forth_@ @ ;
: forth_! ! ;
: forth_and AND ;
: forth_+ + ;
: forth_- - ;
: forth_word WORD ;
: forth_words WORDS ;
: forth_.s .S ;
: CRR cr ;
: forth_.( [COMPILE] .( ;
: forth_count COUNT ;
: forth_r> R> ;
: -or   XOR ;
: >body 5 + ;
: forth_forget FORGET ;
: forth_. . ;
: wf: : ;
: wf; [COMPILE] ; ; immediate
: forth_EXIT EXIT ;
: forth_QUIT quit ;
: target_' forth_' >body forth_@  ;
: -OR   XOR ;

CREATE ram  8000 ALLOT
: RESET   ram 8000 0 FILL ;   RESET
: RAM@    ram +  @ ;
: RAMC@   ram +  C@ ;
: RAM!    ram +  ! ;
: RAMC!   ram +  C! ;

: FOUR   (  a -- ) 4 FOR AFT  DUP RAM@ 9 U.R  4 + THEN NEXT  ;
: SHOW ( a)   10 FOR AFT  CR  DUP 7 .R SPACE
      FOUR SPACE FOUR  THEN NEXT ;
: showram 0 0C FOR AFT SHOW THEN NEXT DROP ;

VARIABLE hFile
: write-bin-file
   Z" mem.bin" 
   $40000000 ( GENERIC_WRITE )
   0 ( share mode )
   0 ( security attribute )
   2 ( CREATE_ALWAYS )
   $80 ( FILE_ATTRIBUTE_NORMAL )
   0 ( hTemplateFile )
   CreateFileA hFile !
      hFile @ 
      RAM 4000
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   hFile @ CloseHandle DROP
   ;

CREATE CRLF-ARRAY 0D C, 0A C,
: CRLF   
      hFile @ 
      CRLF-ARRAY 2
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   ;

: open-mif-file
   Z" rom.mif"
   $40000000 ( GENERIC_WRITE )
   0 ( share mode )
   0 ( security attribute )
   2 ( CREATE_ALWAYS )
   $80 ( FILE_ATTRIBUTE_NORMAL )
   0 ( hTemplateFile )
   CreateFileA hFile !
   ;
: write-mif-header
   CRLF
      hFile @ 
      $" /* WIDTH=32; */" 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   CRLF
      hFile @ 
      $" /* DEPTH=4096; */" 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   CRLF
      hFile @ 
      $" /* ADDRESS_RADIX=HEX; */" 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   CRLF
      hFile @ 
      $" /* DATA_RADIX=HEX; */" 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   CRLF
      hFile @ 
      $" /* CONTENT BEGIN; */" 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   ;

: write-mif-data
   0 ( initial ram location )
   $1000 FOR AFT
      CRLF
      hFile @ 
      OVER ( 4 / )  ( byte address )
      <# 2F HOLD 2A HOLD 20 HOLD 
          7 FOR # NEXT 
      20 HOLD 2A HOLD 2F HOLD #>
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
      hFile @ 
      OVER ram@ 
      <# 2C HOLD 7 FOR # NEXT 78 HOLD 30 HOLD 20 HOLD #>
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
      CELL+
   THEN NEXT
   DROP ( discard ram location )
   ;

: close-mif-file
   CRLF
      hFile @ 
      $" /* END; */" 
      PAD ( lpWrittenBytes )
      0 ( lpOverlapped )
      WriteFile
      IF ELSE ." write error" QUIT THEN
   CRLF
   hFile @ CloseHandle DROP
   ;

: write-mif-file
   open-mif-file
   write-mif-header
   write-mif-data
   close-mif-file
   ;
   
CR .( include assembler )
FLOAD cefASMa.f

: :: makeHead begin .head CONSTANT dolist, aanew DOES> R> @ #, ;
: CREATE makeHead begin .head CONSTANT dovar, next, aanew DOES> R> @ #, ;
: VARIABLE CREATE 0 #, ;

$200 ORG
CR .( include kernel )
FLOAD cefKERNa.f

: ;; EXIT ;

: BEGIN ( -- a ) begin ;
: AGAIN ( a -- ) BRANCH #, ;
: UNTIL ( a -- ) QBRANCH #, ;
: IF ( -- a ) QBRANCH BEGIN 0 #, ;
: ELSE ( a1 -- a2 ) BRANCH BEGIN 0 #, forth_swap
	BEGIN forth_swap RAM! ;
: THEN ( a -- ) BEGIN forth_swap RAM! ;
: WHILE ( a1 -- a2 a1 ) IF forth_swap ;
: REPEAT ( a -- ) BRANCH #, THEN ;
: AFT ( a1 -- a3 a2 ) forth_drop BRANCH BEGIN 0 #, 
	BEGIN forth_swap ;
: FOR ( -- a ) >R BEGIN ;
: NEXT ( a -- ) DONEXT #, ;
: LIT ( n -- ) [ forth_' DOLIT >body forth_@ LITERAL ] #, #, ;

CRR .( include eforth ) 
FLOAD cEFa.f
H forth_@

CRR
0 ORG 
\ 1234 lit#, 5678 lit#, 10000 lit#, ummod,
\ 1234 lit#, 5678 lit#, 10000 lit#, msmod,
\ 1234 lit#, 5678 lit#, 10000 lit#, stasl,
\ 1234 lit#, 5678 lit#, 10000 lit#, ssmod,
\ 1234 lit#, 100 lit#, ddup, slmod, 
\ ddrop, ddup, mod, drop,
\ ddup, slash, drop, ddup,
\ umsta, ddrop, ddup, mstar,
\ ddrop, star, drop,
dolist, aanew
\ 41 LIT EMIT 42 LIT EMIT 43 LIT EMIT       \ debugging words
COLD

$90 ORG $100                             #, \ TIB
$94 ORG $10                              #, \ BASE
$98 ORG lastH forth_@                    #, \ CONTEXT
$9C ORG                                  #, \ CP
$A0 ORG lastH forth_@                    #, \ LAST
$A4 ORG forth_' $INTERPRET >body forth_@ #, \ 'EVAL
$A8 ORG forth_' QUIT >body forth_@  #,      \ 'ABORT
$AC ORG 0                                #, \ tmp

write-mif-file
FLOAD cefSIMa.F
